import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import{Cookie}from"./Cookie.js";import{Events as NetworkRequestEvents,NetworkRequest}from"./NetworkRequest.js";import{Capability}from"./Target.js";import{SDKModel}from"./SDKModel.js";import{TargetManager}from"./TargetManager.js";const UIStrings={noContentForWebSocket:"Content for WebSockets is currently not supported",noContentForRedirect:"No content available because this request was redirected",noContentForPreflight:"No content available for preflight request",noThrottling:"No throttling",offline:"Offline",slowG:"Slow 3G",fastG:"Fast 3G",requestWasBlockedByDevtoolsS:'Request was blocked by DevTools: "{PH1}"',sFailedLoadingSS:'{PH1} failed loading: {PH2} "{PH3}".',sFinishedLoadingSS:'{PH1} finished loading: {PH2} "{PH3}".'},str_=i18n.i18n.registerUIStrings("core/sdk/NetworkManager.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_),requestToManagerMap=new WeakMap,CONNECTION_TYPES=new Map([["2g","cellular2g"],["3g","cellular3g"],["4g","cellular4g"],["bluetooth","bluetooth"],["wifi","wifi"],["wimax","wimax"]]);export class NetworkManager extends SDKModel{dispatcher;fetchDispatcher;#e;#t;constructor(e){super(e),this.dispatcher=new NetworkDispatcher(this),this.fetchDispatcher=new FetchDispatcher(e.fetchAgent(),this),this.#e=e.networkAgent(),e.registerNetworkDispatcher(this.dispatcher),e.registerFetchDispatcher(this.fetchDispatcher),Common.Settings.Settings.instance().moduleSetting("cacheDisabled").get()&&this.#e.invoke_setCacheDisabled({cacheDisabled:!0}),this.#e.invoke_enable({maxPostDataSize:MAX_EAGER_POST_REQUEST_BODY_LENGTH}),this.#e.invoke_setAttachDebugStack({enabled:!0}),this.#t=Common.Settings.Settings.instance().createSetting("bypassServiceWorker",!1),this.#t.get()&&this.bypassServiceWorkerChanged(),this.#t.addChangeListener(this.bypassServiceWorkerChanged,this),Common.Settings.Settings.instance().moduleSetting("cacheDisabled").addChangeListener(this.cacheDisabledSettingChanged,this)}static forRequest(e){return requestToManagerMap.get(e)||null}static canReplayRequest(e){return Boolean(requestToManagerMap.get(e))&&Boolean(e.backendRequestId())&&!e.isRedirect()&&e.resourceType()===Common.ResourceType.resourceTypes.XHR}static replayRequest(e){const t=requestToManagerMap.get(e),s=e.backendRequestId();t&&s&&!e.isRedirect()&&t.#e.invoke_replayXHR({requestId:s})}static async searchInRequest(e,t,s,r){const n=NetworkManager.forRequest(e),o=e.backendRequestId();if(!n||!o||e.isRedirect())return[];return(await n.#e.invoke_searchInResponseBody({requestId:o,query:t,caseSensitive:s,isRegex:r})).result||[]}static async requestContentData(e){if(e.resourceType()===Common.ResourceType.resourceTypes.WebSocket)return{error:i18nString(UIStrings.noContentForWebSocket),content:null,encoded:!1};if(e.finished||await e.once(NetworkRequestEvents.FinishedLoading),e.isRedirect())return{error:i18nString(UIStrings.noContentForRedirect),content:null,encoded:!1};if(e.isPreflightRequest())return{error:i18nString(UIStrings.noContentForPreflight),content:null,encoded:!1};const t=NetworkManager.forRequest(e);if(!t)return{error:"No network manager for request",content:null,encoded:!1};const s=e.backendRequestId();if(!s)return{error:"No backend request id for request",content:null,encoded:!1};const r=await t.#e.invoke_getResponseBody({requestId:s}),n=r.getError()||null;return{error:n,content:n?null:r.body,encoded:r.base64Encoded}}static async requestPostData(e){const t=NetworkManager.forRequest(e);if(!t)return console.error("No network manager for request"),null;const s=e.backendRequestId();if(!s)return console.error("No backend request id for request"),null;try{const{postData:e}=await t.#e.invoke_getRequestPostData({requestId:s});return e}catch(e){return e.message}}static connectionType(e){if(!e.download&&!e.upload)return"none";const t="function"==typeof e.title?e.title().toLowerCase():e.title.toLowerCase();for(const[e,s]of CONNECTION_TYPES)if(t.includes(e))return s;return"other"}static lowercaseHeaders(e){const t={};for(const s in e)t[s.toLowerCase()]=e[s];return t}requestForURL(e){return this.dispatcher.requestForURL(e)}requestForId(e){return this.dispatcher.requestForId(e)}requestForLoaderId(e){return this.dispatcher.requestForLoaderId(e)}cacheDisabledSettingChanged({data:e}){this.#e.invoke_setCacheDisabled({cacheDisabled:e})}dispose(){Common.Settings.Settings.instance().moduleSetting("cacheDisabled").removeChangeListener(this.cacheDisabledSettingChanged,this)}bypassServiceWorkerChanged(){this.#e.invoke_setBypassServiceWorker({bypass:this.#t.get()})}async getSecurityIsolationStatus(e){const t=await this.#e.invoke_getSecurityIsolationStatus({frameId:e??void 0});return t.getError()?null:t.status}async enableReportingApi(e=!0){return this.#e.invoke_enableReportingApi({enable:e})}async loadNetworkResource(e,t,s){const r=await this.#e.invoke_loadNetworkResource({frameId:e??void 0,url:t,options:s});if(r.getError())throw new Error(r.getError());return r.resource}clearRequests(){this.dispatcher.clearRequests()}}export var Events;!function(e){e.RequestStarted="RequestStarted",e.RequestUpdated="RequestUpdated",e.RequestFinished="RequestFinished",e.RequestUpdateDropped="RequestUpdateDropped",e.ResponseReceived="ResponseReceived",e.MessageGenerated="MessageGenerated",e.RequestRedirected="RequestRedirected",e.LoadingFinished="LoadingFinished",e.ReportingApiReportAdded="ReportingApiReportAdded",e.ReportingApiReportUpdated="ReportingApiReportUpdated",e.ReportingApiEndpointsChangedForOrigin="ReportingApiEndpointsChangedForOrigin"}(Events||(Events={}));export const NoThrottlingConditions={title:i18nLazyString(UIStrings.noThrottling),i18nTitleKey:UIStrings.noThrottling,download:-1,upload:-1,latency:0};export const OfflineConditions={title:i18nLazyString(UIStrings.offline),i18nTitleKey:UIStrings.offline,download:0,upload:0,latency:0};export const Slow3GConditions={title:i18nLazyString(UIStrings.slowG),i18nTitleKey:UIStrings.slowG,download:5e4,upload:5e4,latency:2e3};export const Fast3GConditions={title:i18nLazyString(UIStrings.fastG),i18nTitleKey:UIStrings.fastG,download:18e4,upload:84375,latency:562.5};const MAX_EAGER_POST_REQUEST_BODY_LENGTH=65536;export class FetchDispatcher{#s;#r;constructor(e,t){this.#s=e,this.#r=t}requestPaused({requestId:e,request:t,resourceType:s,responseStatusCode:r,responseHeaders:n,networkId:o}){const i=o?this.#r.requestForId(o):null;0===i?.originalResponseHeaders.length&&n&&(i.originalResponseHeaders=n),MultitargetNetworkManager.instance().requestIntercepted(new InterceptedRequest(this.#s,t,s,e,i,r,n))}authRequired({}){}}export class NetworkDispatcher{#r;#n;#o;#i;#a;#d;constructor(e){this.#r=e,this.#n=new Map,this.#o=new Map,this.#i=new Map,this.#a=new Map,this.#d=new Map,MultitargetNetworkManager.instance().addEventListener(MultitargetNetworkManager.Events.RequestIntercepted,this.#u.bind(this))}#u(e){const t=this.requestForId(e.data);t&&t.setWasIntercepted(!0)}headersMapToHeadersArray(e){const t=[];for(const s in e){const r=e[s].split("\n");for(let e=0;e<r.length;++e)t.push({name:s,value:r[e]})}return t}updateNetworkRequestWithRequest(e,t){e.requestMethod=t.method,e.setRequestHeaders(this.headersMapToHeadersArray(t.headers)),e.setRequestFormData(Boolean(t.hasPostData),t.postData||null),e.setInitialPriority(t.initialPriority),e.mixedContentType=t.mixedContentType||"none",e.setReferrerPolicy(t.referrerPolicy),e.setIsSameSite(t.isSameSite||!1)}updateNetworkRequestWithResponse(e,t){t.url&&e.url()!==t.url&&e.setUrl(t.url),e.mimeType=t.mimeType,e.statusCode&&!e.wasIntercepted()||(e.statusCode=t.status),e.statusText&&!e.wasIntercepted()||(e.statusText=t.statusText),e.hasExtraResponseInfo()&&!e.wasIntercepted()||(e.responseHeaders=this.headersMapToHeadersArray(t.headers)),t.encodedDataLength>=0&&e.setTransferSize(t.encodedDataLength),t.requestHeaders&&!e.hasExtraRequestInfo()&&(e.setRequestHeaders(this.headersMapToHeadersArray(t.requestHeaders)),e.setRequestHeadersText(t.requestHeadersText||"")),e.connectionReused=t.connectionReused,e.connectionId=String(t.connectionId),t.remoteIPAddress&&e.setRemoteAddress(t.remoteIPAddress,t.remotePort||-1),t.fromServiceWorker&&(e.fetchedViaServiceWorker=!0),t.fromDiskCache&&e.setFromDiskCache(),t.fromPrefetchCache&&e.setFromPrefetchCache(),t.cacheStorageCacheName&&e.setResponseCacheStorageCacheName(t.cacheStorageCacheName),t.responseTime&&e.setResponseRetrievalTime(new Date(t.responseTime)),e.timing=t.timing,e.protocol=t.protocol||"",e.alternateProtocolUsage=t.alternateProtocolUsage,t.serviceWorkerResponseSource&&e.setServiceWorkerResponseSource(t.serviceWorkerResponseSource),e.setSecurityState(t.securityState),t.securityDetails&&e.setSecurityDetails(t.securityDetails);const s=Common.ResourceType.ResourceType.fromMimeTypeOverride(e.mimeType);s&&e.setResourceType(s)}requestForId(e){return this.#n.get(e)||null}requestForURL(e){return this.#o.get(e)||null}requestForLoaderId(e){return this.#i.get(e)||null}resourceChangedPriority({requestId:e,newPriority:t}){const s=this.#n.get(e);s&&s.setPriority(t)}signedExchangeReceived({requestId:e,info:t}){let s=this.#n.get(e);(s||(s=this.#o.get(t.outerResponse.url),s))&&(s.setSignedExchangeInfo(t),s.setResourceType(Common.ResourceType.resourceTypes.SignedExchange),this.updateNetworkRequestWithResponse(s,t.outerResponse),this.updateNetworkRequest(s),this.#r.dispatchEventToListeners(Events.ResponseReceived,{request:s,response:t.outerResponse}))}requestWillBeSent({requestId:e,loaderId:t,documentURL:s,request:r,timestamp:n,wallTime:o,initiator:i,redirectResponse:a,type:d,frameId:u,hasUserGesture:c}){let l=this.#n.get(e);if(l){if(!a)return;l.signedExchangeInfo()||this.responseReceived({requestId:e,loaderId:t,timestamp:n,type:d||"Other",response:a,hasExtraInfo:!1,frameId:u}),l=this.appendRedirect(e,n,r.url),this.#r.dispatchEventToListeners(Events.RequestRedirected,l)}else l=NetworkRequest.create(e,r.url,s,u??null,t,i,c),requestToManagerMap.set(l,this.#r);l.hasNetworkData=!0,this.updateNetworkRequestWithRequest(l,r),l.setIssueTime(n,o),l.setResourceType(d?Common.ResourceType.resourceTypes[d]:Common.ResourceType.resourceTypes.Other),r.trustTokenParams&&l.setTrustTokenParams(r.trustTokenParams);const h=this.#d.get(e);h&&(l.setTrustTokenOperationDoneEvent(h),this.#d.delete(e)),this.getExtraInfoBuilder(e).addRequest(l),this.startNetworkRequest(l,r)}requestServedFromCache({requestId:e}){const t=this.#n.get(e);t&&t.setFromMemoryCache()}responseReceived({requestId:e,loaderId:t,timestamp:s,type:r,response:n,frameId:o}){const i=this.#n.get(e),a=NetworkManager.lowercaseHeaders(n.headers);if(i)i.responseReceivedTime=s,i.setResourceType(Common.ResourceType.resourceTypes[r]),this.updateNetworkRequestWithResponse(i,n),this.updateNetworkRequest(i),this.#r.dispatchEventToListeners(Events.ResponseReceived,{request:i,response:n});else{const e=a["last-modified"],s={url:n.url,frameId:o??null,loaderId:t,resourceType:r,mimeType:n.mimeType,lastModified:e?new Date(e):null};this.#r.dispatchEventToListeners(Events.RequestUpdateDropped,s)}}dataReceived({requestId:e,timestamp:t,dataLength:s,encodedDataLength:r}){let n=this.#n.get(e);n||(n=this.maybeAdoptMainResourceRequest(e)),n&&(n.resourceSize+=s,-1!==r&&n.increaseTransferSize(r),n.endTime=t,this.updateNetworkRequest(n))}loadingFinished({requestId:e,timestamp:t,encodedDataLength:s}){let r=this.#n.get(e);r||(r=this.maybeAdoptMainResourceRequest(e)),r&&(this.getExtraInfoBuilder(e).finished(),this.finishNetworkRequest(r,t,s),this.#r.dispatchEventToListeners(Events.LoadingFinished,r))}loadingFailed({requestId:e,timestamp:t,type:s,errorText:r,canceled:n,blockedReason:o,corsErrorStatus:i}){const a=this.#n.get(e);if(a){if(a.failed=!0,a.setResourceType(Common.ResourceType.resourceTypes[s]),a.canceled=Boolean(n),o&&(a.setBlockedReason(o),"inspector"===o)){const t=i18nString(UIStrings.requestWasBlockedByDevtoolsS,{PH1:a.url()});this.#r.dispatchEventToListeners(Events.MessageGenerated,{message:t,requestId:e,warning:!0})}i&&a.setCorsErrorStatus(i),a.localizedFailDescription=r,this.getExtraInfoBuilder(e).finished(),this.finishNetworkRequest(a,t,-1)}}webSocketCreated({requestId:e,url:t,initiator:s}){const r=NetworkRequest.createForWebSocket(e,t,s);requestToManagerMap.set(r,this.#r),r.setResourceType(Common.ResourceType.resourceTypes.WebSocket),this.startNetworkRequest(r,null)}webSocketWillSendHandshakeRequest({requestId:e,timestamp:t,wallTime:s,request:r}){const n=this.#n.get(e);n&&(n.requestMethod="GET",n.setRequestHeaders(this.headersMapToHeadersArray(r.headers)),n.setIssueTime(t,s),this.updateNetworkRequest(n))}webSocketHandshakeResponseReceived({requestId:e,timestamp:t,response:s}){const r=this.#n.get(e);r&&(r.statusCode=s.status,r.statusText=s.statusText,r.responseHeaders=this.headersMapToHeadersArray(s.headers),r.responseHeadersText=s.headersText||"",s.requestHeaders&&r.setRequestHeaders(this.headersMapToHeadersArray(s.requestHeaders)),s.requestHeadersText&&r.setRequestHeadersText(s.requestHeadersText),r.responseReceivedTime=t,r.protocol="websocket",this.updateNetworkRequest(r))}webSocketFrameReceived({requestId:e,timestamp:t,response:s}){const r=this.#n.get(e);r&&(r.addProtocolFrame(s,t,!1),r.responseReceivedTime=t,this.updateNetworkRequest(r))}webSocketFrameSent({requestId:e,timestamp:t,response:s}){const r=this.#n.get(e);r&&(r.addProtocolFrame(s,t,!0),r.responseReceivedTime=t,this.updateNetworkRequest(r))}webSocketFrameError({requestId:e,timestamp:t,errorMessage:s}){const r=this.#n.get(e);r&&(r.addProtocolFrameError(s,t),r.responseReceivedTime=t,this.updateNetworkRequest(r))}webSocketClosed({requestId:e,timestamp:t}){const s=this.#n.get(e);s&&this.finishNetworkRequest(s,t,-1)}eventSourceMessageReceived({requestId:e,timestamp:t,eventName:s,eventId:r,data:n}){const o=this.#n.get(e);o&&o.addEventSourceMessage(t,s,r,n)}requestIntercepted({}){}requestWillBeSentExtraInfo({requestId:e,associatedCookies:t,headers:s,clientSecurityState:r,connectTiming:n,siteHasCookieInOtherPartition:o}){const i=[],a=[];for(const{blockedReasons:e,cookie:s}of t)0===e.length?a.push(Cookie.fromProtocolCookie(s)):i.push({blockedReasons:e,cookie:Cookie.fromProtocolCookie(s)});const d={blockedRequestCookies:i,includedRequestCookies:a,requestHeaders:this.headersMapToHeadersArray(s),clientSecurityState:r,connectTiming:n,siteHasCookieInOtherPartition:o};this.getExtraInfoBuilder(e).addRequestExtraInfo(d)}responseReceivedExtraInfo({requestId:e,blockedCookies:t,headers:s,headersText:r,resourceIPAddressSpace:n,statusCode:o,cookiePartitionKey:i,cookiePartitionKeyOpaque:a}){const d={blockedResponseCookies:t.map((e=>({blockedReasons:e.blockedReasons,cookieLine:e.cookieLine,cookie:e.cookie?Cookie.fromProtocolCookie(e.cookie):null}))),responseHeaders:this.headersMapToHeadersArray(s),responseHeadersText:r,resourceIPAddressSpace:n,statusCode:o,cookiePartitionKey:i,cookiePartitionKeyOpaque:a};this.getExtraInfoBuilder(e).addResponseExtraInfo(d)}getExtraInfoBuilder(e){let t;return this.#a.has(e)?t=this.#a.get(e):(t=new ExtraInfoBuilder,this.#a.set(e,t)),t}appendRedirect(e,t,s){const r=this.#n.get(e);if(!r)throw new Error(`Could not find original network request for ${e}`);let n=0;for(let e=r.redirectSource();e;e=e.redirectSource())n++;r.markAsRedirect(n),this.finishNetworkRequest(r,t,-1);const o=NetworkRequest.create(e,s,r.documentURL,r.frameId,r.loaderId,r.initiator(),r.hasUserGesture()??void 0);return requestToManagerMap.set(o,this.#r),o.setRedirectSource(r),r.setRedirectDestination(o),o}maybeAdoptMainResourceRequest(e){const t=MultitargetNetworkManager.instance().inflightMainResourceRequests.get(e);if(!t)return null;const s=NetworkManager.forRequest(t).dispatcher;s.#n.delete(e),s.#o.delete(t.url());const r=t.loaderId;r&&s.#i.delete(r);const n=s.#a.get(e);return s.#a.delete(e),this.#n.set(e,t),this.#o.set(t.url(),t),r&&this.#i.set(r,t),n&&this.#a.set(e,n),requestToManagerMap.set(t,this.#r),t}startNetworkRequest(e,t){this.#n.set(e.requestId(),e),this.#o.set(e.url(),e);const s=e.loaderId;s&&this.#i.set(s,e),e.loaderId===e.requestId()&&MultitargetNetworkManager.instance().inflightMainResourceRequests.set(e.requestId(),e),this.#r.dispatchEventToListeners(Events.RequestStarted,{request:e,originalRequest:t})}updateNetworkRequest(e){this.#r.dispatchEventToListeners(Events.RequestUpdated,e)}finishNetworkRequest(e,t,s){if(e.endTime=t,e.finished=!0,s>=0){const t=e.redirectSource();t&&t.signedExchangeInfo()?(e.setTransferSize(0),t.setTransferSize(s),this.updateNetworkRequest(t)):e.setTransferSize(s)}if(this.#r.dispatchEventToListeners(Events.RequestFinished,e),MultitargetNetworkManager.instance().inflightMainResourceRequests.delete(e.requestId()),Common.Settings.Settings.instance().moduleSetting("monitoringXHREnabled").get()&&e.resourceType().category()===Common.ResourceType.resourceCategories.XHR){let t;const s=e.failed||e.hasErrorStatusCode();t=i18nString(s?UIStrings.sFailedLoadingSS:UIStrings.sFinishedLoadingSS,{PH1:e.resourceType().title(),PH2:e.requestMethod,PH3:e.url()}),this.#r.dispatchEventToListeners(Events.MessageGenerated,{message:t,requestId:e.requestId(),warning:!1})}}clearRequests(){for(const[e,t]of this.#n)t.finished&&this.#n.delete(e);for(const[e,t]of this.#o)t.finished&&this.#o.delete(e);for(const[e,t]of this.#i)t.finished&&this.#i.delete(e);for(const[e,t]of this.#a)t.isFinished()&&this.#a.delete(e)}webTransportCreated({transportId:e,url:t,timestamp:s,initiator:r}){const n=NetworkRequest.createForWebSocket(e,t,r);n.hasNetworkData=!0,requestToManagerMap.set(n,this.#r),n.setResourceType(Common.ResourceType.resourceTypes.WebTransport),n.setIssueTime(s,0),this.startNetworkRequest(n,null)}webTransportConnectionEstablished({transportId:e,timestamp:t}){const s=this.#n.get(e);s&&(s.responseReceivedTime=t,s.endTime=t+.001,this.updateNetworkRequest(s))}webTransportClosed({transportId:e,timestamp:t}){const s=this.#n.get(e);s&&(s.endTime=t,this.finishNetworkRequest(s,t,0))}trustTokenOperationDone(e){const t=this.#n.get(e.requestId);t?t.setTrustTokenOperationDoneEvent(e):this.#d.set(e.requestId,e)}subresourceWebBundleMetadataReceived({requestId:e,urls:t}){const s=this.getExtraInfoBuilder(e);s.setWebBundleInfo({resourceUrls:t});const r=s.finalRequest();r&&this.updateNetworkRequest(r)}subresourceWebBundleMetadataError({requestId:e,errorMessage:t}){const s=this.getExtraInfoBuilder(e);s.setWebBundleInfo({errorMessage:t});const r=s.finalRequest();r&&this.updateNetworkRequest(r)}subresourceWebBundleInnerResponseParsed({innerRequestId:e,bundleRequestId:t}){const s=this.getExtraInfoBuilder(e);s.setWebBundleInnerRequestInfo({bundleRequestId:t});const r=s.finalRequest();r&&this.updateNetworkRequest(r)}subresourceWebBundleInnerResponseError({innerRequestId:e,errorMessage:t}){const s=this.getExtraInfoBuilder(e);s.setWebBundleInnerRequestInfo({errorMessage:t});const r=s.finalRequest();r&&this.updateNetworkRequest(r)}reportingApiReportAdded(e){this.#r.dispatchEventToListeners(Events.ReportingApiReportAdded,e.report)}reportingApiReportUpdated(e){this.#r.dispatchEventToListeners(Events.ReportingApiReportUpdated,e.report)}reportingApiEndpointsChangedForOrigin(e){this.#r.dispatchEventToListeners(Events.ReportingApiEndpointsChangedForOrigin,e)}createNetworkRequest(e,t,s,r,n,o){const i=NetworkRequest.create(e,r,n,t,s,o);return requestToManagerMap.set(i,this.#r),i}}let multiTargetNetworkManagerInstance;export class MultitargetNetworkManager extends Common.ObjectWrapper.ObjectWrapper{#c;#l;#h;#g;#p;inflightMainResourceRequests;#f;#q;#R;#k;#I;#m;#w;#T;constructor(){super(),this.#c="",this.#l=null,this.#h=null,this.#g=new Set,this.#p=new Set,this.inflightMainResourceRequests=new Map,this.#f=NoThrottlingConditions,this.#q=null,this.#R=Common.Settings.Settings.instance().moduleSetting("requestBlockingEnabled"),this.#k=Common.Settings.Settings.instance().createSetting("networkBlockedPatterns",[]),this.#I=[],this.updateBlockedPatterns(),this.#m=new Platform.MapUtilities.Multimap,TargetManager.instance().observeModels(NetworkManager,this)}static instance(e={forceNew:null}){const{forceNew:t}=e;return multiTargetNetworkManagerInstance&&!t||(multiTargetNetworkManagerInstance=new MultitargetNetworkManager),multiTargetNetworkManagerInstance}static dispose(){multiTargetNetworkManagerInstance=null}static getChromeVersion(){const e=navigator.userAgent.match(/(?:^|\W)(?:Chrome|HeadlessChrome)\/(\S+)/);return e&&e.length>1?e[1]:""}static patchUserAgentWithChromeVersion(e){const t=MultitargetNetworkManager.getChromeVersion();if(t.length>0){const s=t.split(".",1)[0]+".0.100.0";return Platform.StringUtilities.sprintf(e,t,s)}return e}static patchUserAgentMetadataWithChromeVersion(e){if(!e.brands)return;const t=MultitargetNetworkManager.getChromeVersion();if(0===t.length)return;const s=t.split(".",1)[0];for(const t of e.brands)t.version.includes("%s")&&(t.version=Platform.StringUtilities.sprintf(t.version,s));e.fullVersion&&e.fullVersion.includes("%s")&&(e.fullVersion=Platform.StringUtilities.sprintf(e.fullVersion,t))}modelAdded(e){const t=e.target().networkAgent(),s=e.target().fetchAgent();this.#w&&t.invoke_setExtraHTTPHeaders({headers:this.#w}),this.currentUserAgent()&&t.invoke_setUserAgentOverride({userAgent:this.currentUserAgent(),userAgentMetadata:this.#l||void 0}),this.#I.length&&t.invoke_setBlockedURLs({urls:this.#I}),this.isIntercepting()&&s.invoke_enable({patterns:this.#m.valuesArray()}),null===this.#h?t.invoke_clearAcceptedEncodingsOverride():t.invoke_setAcceptedEncodings({encodings:this.#h}),this.#g.add(t),this.#p.add(s),this.isThrottling()&&this.updateNetworkConditions(t)}modelRemoved(e){for(const t of this.inflightMainResourceRequests){NetworkManager.forRequest(t[1])===e&&this.inflightMainResourceRequests.delete(t[0])}this.#g.delete(e.target().networkAgent()),this.#p.delete(e.target().fetchAgent())}isThrottling(){return this.#f.download>=0||this.#f.upload>=0||this.#f.latency>0}isOffline(){return!this.#f.download&&!this.#f.upload}setNetworkConditions(e){this.#f=e;for(const e of this.#g)this.updateNetworkConditions(e);this.dispatchEventToListeners(MultitargetNetworkManager.Events.ConditionsChanged)}networkConditions(){return this.#f}updateNetworkConditions(e){const t=this.#f;this.isThrottling()?e.invoke_emulateNetworkConditions({offline:this.isOffline(),latency:t.latency,downloadThroughput:t.download<0?0:t.download,uploadThroughput:t.upload<0?0:t.upload,connectionType:NetworkManager.connectionType(t)}):e.invoke_emulateNetworkConditions({offline:!1,latency:0,downloadThroughput:0,uploadThroughput:0})}setExtraHTTPHeaders(e){this.#w=e;for(const e of this.#g)e.invoke_setExtraHTTPHeaders({headers:this.#w})}currentUserAgent(){return this.#T?this.#T:this.#c}updateUserAgentOverride(){const e=this.currentUserAgent();for(const t of this.#g)t.invoke_setUserAgentOverride({userAgent:e,userAgentMetadata:this.#l||void 0})}setUserAgentOverride(e,t){const s=this.#c!==e;this.#c=e,this.#T?this.#l=null:(this.#l=t,this.updateUserAgentOverride()),s&&this.dispatchEventToListeners(MultitargetNetworkManager.Events.UserAgentChanged)}userAgentOverride(){return this.#c}setCustomUserAgentOverride(e,t=null){this.#T=e,this.#l=t,this.updateUserAgentOverride()}setCustomAcceptedEncodingsOverride(e){this.#h=e,this.updateAcceptedEncodingsOverride(),this.dispatchEventToListeners(MultitargetNetworkManager.Events.AcceptedEncodingsChanged)}clearCustomAcceptedEncodingsOverride(){this.#h=null,this.updateAcceptedEncodingsOverride(),this.dispatchEventToListeners(MultitargetNetworkManager.Events.AcceptedEncodingsChanged)}isAcceptedEncodingOverrideSet(){return null!==this.#h}updateAcceptedEncodingsOverride(){const e=this.#h;for(const t of this.#g)null===e?t.invoke_clearAcceptedEncodingsOverride():t.invoke_setAcceptedEncodings({encodings:e})}blockedPatterns(){return this.#k.get().slice()}blockingEnabled(){return this.#R.get()}isBlocking(){return Boolean(this.#I.length)}setBlockedPatterns(e){this.#k.set(e),this.updateBlockedPatterns(),this.dispatchEventToListeners(MultitargetNetworkManager.Events.BlockedPatternsChanged)}setBlockingEnabled(e){this.#R.get()!==e&&(this.#R.set(e),this.updateBlockedPatterns(),this.dispatchEventToListeners(MultitargetNetworkManager.Events.BlockedPatternsChanged))}updateBlockedPatterns(){const e=[];if(this.#R.get())for(const t of this.#k.get())t.enabled&&e.push(t.url);if(e.length||this.#I.length){this.#I=e;for(const e of this.#g)e.invoke_setBlockedURLs({urls:this.#I})}}isIntercepting(){return Boolean(this.#m.size)}setInterceptionHandlerForPatterns(e,t){this.#m.deleteAll(t);for(const s of e)this.#m.set(t,s);return this.updateInterceptionPatternsOnNextTick()}updateInterceptionPatternsOnNextTick(){return this.#q||(this.#q=Promise.resolve().then(this.updateInterceptionPatterns.bind(this))),this.#q}async updateInterceptionPatterns(){Common.Settings.Settings.instance().moduleSetting("cacheDisabled").get()||Common.Settings.Settings.instance().moduleSetting("cacheDisabled").set(!0),this.#q=null;const e=[];for(const t of this.#p)e.push(t.invoke_enable({patterns:this.#m.valuesArray()}));this.dispatchEventToListeners(MultitargetNetworkManager.Events.InterceptorsChanged),await Promise.all(e)}async requestIntercepted(e){for(const t of this.#m.keysArray())if(await t(e),e.hasResponded()&&e.networkRequest)return void this.dispatchEventToListeners(MultitargetNetworkManager.Events.RequestIntercepted,e.networkRequest.requestId());e.hasResponded()||e.continueRequestWithoutChange()}clearBrowserCache(){for(const e of this.#g)e.invoke_clearBrowserCache()}clearBrowserCookies(){for(const e of this.#g)e.invoke_clearBrowserCookies()}async getCertificate(e){const t=TargetManager.instance().primaryPageTarget();if(!t)return[];const s=await t.networkAgent().invoke_getCertificate({origin:e});return s?s.tableNames:[]}async loadResource(e){const t={},s=this.currentUserAgent();s&&(t["User-Agent"]=s),Common.Settings.Settings.instance().moduleSetting("cacheDisabled").get()&&(t["Cache-Control"]="no-cache");const r=Common.Settings.Settings.instance().moduleSetting("network.enable-remote-file-loading").get();return new Promise((s=>Host.ResourceLoader.load(e,t,((e,t,r,n)=>{s({success:e,content:r,errorDescription:n})}),r)))}}!function(e){let t;!function(e){e.BlockedPatternsChanged="BlockedPatternsChanged",e.ConditionsChanged="ConditionsChanged",e.UserAgentChanged="UserAgentChanged",e.InterceptorsChanged="InterceptorsChanged",e.AcceptedEncodingsChanged="AcceptedEncodingsChanged",e.RequestIntercepted="RequestIntercepted",e.RequestFulfilled="RequestFulfilled"}(t=e.Events||(e.Events={}))}(MultitargetNetworkManager||(MultitargetNetworkManager={}));export class InterceptedRequest{#s;#v;request;resourceType;responseStatusCode;responseHeaders;requestId;networkRequest;constructor(e,t,s,r,n,o,i){this.#s=e,this.#v=!1,this.request=t,this.resourceType=s,this.responseStatusCode=o,this.responseHeaders=i,this.requestId=r,this.networkRequest=n}hasResponded(){return this.#v}static mergeSetCookieHeaders(e,t){const s=e=>{const t=new Map;for(const s of e){const e=s.value.match(/^([a-zA-Z0-9!#$%&'*+.^_`|~-]+=)(.*)$/);e?t.has(e[1])?t.get(e[1])?.push(s.value):t.set(e[1],[s.value]):t.has(s.value)?t.get(s.value)?.push(s.value):t.set(s.value,[s.value])}return t},r=s(e),n=s(t),o=[];for(const[e,t]of r)if(n.has(e))for(const t of n.get(e)||[])o.push({name:"set-cookie",value:t});else for(const e of t)o.push({name:"set-cookie",value:e});for(const[e,t]of n)if(!r.has(e))for(const e of t)o.push({name:"set-cookie",value:e});return o}async continueRequestWithContent(e,t,s,r){this.#v=!0;const n=t?await e.text():await async function(e){const t=new FileReader,s=new Promise((e=>{t.onloadend=e}));if(t.readAsDataURL(e),await s,t.error)return console.error("Could not convert blob to base64.",t.error),"";const r=t.result;if(null==r||"string"!=typeof r)return console.error("Could not convert blob to base64."),"";return r.substring(r.indexOf(",")+1)}(e),o=r?200:this.responseStatusCode||200;if(this.networkRequest){const e=this.networkRequest?.originalResponseHeaders.filter((e=>"set-cookie"===e.name))||[],t=s.filter((e=>"set-cookie"===e.name));this.networkRequest.setCookieHeaders=InterceptedRequest.mergeSetCookieHeaders(e,t),this.networkRequest.hasOverriddenContent=r}this.#s.invoke_fulfillRequest({requestId:this.requestId,responseCode:o,body:n,responseHeaders:s}),MultitargetNetworkManager.instance().dispatchEventToListeners(MultitargetNetworkManager.Events.RequestFulfilled,this.request.url)}continueRequestWithoutChange(){console.assert(!this.#v),this.#v=!0,this.#s.invoke_continueRequest({requestId:this.requestId})}continueRequestWithError(e){console.assert(!this.#v),this.#v=!0,this.#s.invoke_failRequest({requestId:this.requestId,errorReason:e})}async responseBody(){const e=await this.#s.invoke_getResponseBody({requestId:this.requestId}),t=e.getError()||null;return{error:t,content:t?null:e.body,encoded:e.base64Encoded}}isRedirect(){return void 0!==this.responseStatusCode&&this.responseStatusCode>=300&&this.responseStatusCode<400}}class ExtraInfoBuilder{#y;#S;#E;#C;#A;#b;constructor(){this.#y=[],this.#S=[],this.#E=[],this.#C=!1,this.#A=null,this.#b=null}addRequest(e){this.#y.push(e),this.sync(this.#y.length-1)}addRequestExtraInfo(e){this.#S.push(e),this.sync(this.#S.length-1)}addResponseExtraInfo(e){this.#E.push(e),this.sync(this.#E.length-1)}setWebBundleInfo(e){this.#A=e,this.updateFinalRequest()}setWebBundleInnerRequestInfo(e){this.#b=e,this.updateFinalRequest()}finished(){this.#C=!0,this.updateFinalRequest()}isFinished(){return this.#C}sync(e){const t=this.#y[e];if(!t)return;const s=this.#S[e];s&&(t.addExtraRequestInfo(s),this.#S[e]=null);const r=this.#E[e];r&&(t.addExtraResponseInfo(r),this.#E[e]=null)}finalRequest(){return this.#C&&this.#y[this.#y.length-1]||null}updateFinalRequest(){if(!this.#C)return;const e=this.finalRequest();e?.setWebBundleInfo(this.#A),e?.setWebBundleInnerRequestInfo(this.#b)}}SDKModel.register(NetworkManager,{capabilities:Capability.Network,autostart:!0});export class ConditionsSerializer{stringify(e){const t=e;return JSON.stringify({...t,title:"function"==typeof t.title?t.title():t.title})}parse(e){const t=JSON.parse(e);return{...t,title:t.i18nTitleKey?i18nLazyString(t.i18nTitleKey):t.title}}}export function networkConditionsEqual(e,t){const s="function"==typeof e.title?e.title():e.title,r="function"==typeof t.title?t.title():t.title;return t.download===e.download&&t.upload===e.upload&&t.latency===e.latency&&r===s}