import*as Common from"../../../core/common/common.js";import*as Host from"../../../core/host/host.js";import*as i18n from"../../../core/i18n/i18n.js";import*as SDK from"../../../core/sdk/sdk.js";import*as UI from"../../legacy/legacy.js";import{LinearMemoryInspectorPaneImpl}from"./LinearMemoryInspectorPane.js";import{getDefaultValueTypeMapping}from"./ValueInterpreterDisplayUtils.js";import*as Bindings from"../../../models/bindings/bindings.js";const UIStrings={couldNotOpenLinearMemory:"Could not open linear memory inspector: failed locating buffer."},str_=i18n.i18n.registerUIStrings("ui/components/linear_memory_inspector/LinearMemoryInspectorController.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),LINEAR_MEMORY_INSPECTOR_OBJECT_GROUP="linear-memory-inspector",MEMORY_TRANSFER_MIN_CHUNK_SIZE=1e3;export const ACCEPTED_MEMORY_TYPES=["webassemblymemory","typedarray","dataview","arraybuffer"];let controllerInstance;export class RemoteArrayBufferWrapper{#e;constructor(e){this.#e=e}length(){return this.#e.byteLength()}async getRange(e,t){const r=Math.min(t,this.length());if(e<0||e>r)return console.error(`Requesting invalid range of memory: (${e}, ${t})`),new Uint8Array(0);const n=await this.#e.bytes(e,r);return new Uint8Array(n)}}async function getBufferFromObject(e){console.assert("object"===e.type),console.assert(void 0!==e.subtype&&ACCEPTED_MEMORY_TYPES.includes(e.subtype));const t=await e.runtimeModel().agent.invoke_callFunctionOn({objectId:e.objectId,functionDeclaration:"function() { return this instanceof ArrayBuffer || (typeof SharedArrayBuffer !== 'undefined' && this instanceof SharedArrayBuffer) ? this : this.buffer; }",silent:!0,objectGroup:"linear-memory-inspector"}),r=t.getError();if(r)throw new Error(`Remote object representing ArrayBuffer could not be retrieved: ${r}`);return e=e.runtimeModel().createRemoteObject(t.result),new SDK.RemoteObject.RemoteArrayBuffer(e)}export function isDWARFMemoryObject(e){return e instanceof Bindings.DebuggerLanguagePlugins.ExtensionRemoteObject&&void 0!==e.linearMemoryAddress}export function isMemoryObjectProperty(e){return!!("object"===e.type&&e.subtype&&ACCEPTED_MEMORY_TYPES.includes(e.subtype)||isDWARFMemoryObject(e))}export class LinearMemoryInspectorController extends SDK.TargetManager.SDKModelObserver{#t=LinearMemoryInspectorPaneImpl.instance();#r=new Map;#n=new Map;#o;constructor(){super(),SDK.TargetManager.TargetManager.instance().observeModels(SDK.RuntimeModel.RuntimeModel,this),SDK.TargetManager.TargetManager.instance().addModelListener(SDK.DebuggerModel.DebuggerModel,SDK.DebuggerModel.Events.GlobalObjectCleared,this.#s,this),this.#t.addEventListener("ViewClosed",this.#i.bind(this)),SDK.TargetManager.TargetManager.instance().addModelListener(SDK.DebuggerModel.DebuggerModel,SDK.DebuggerModel.Events.DebuggerPaused,this.#a,this);const e=getDefaultValueTypeMapping(),t={valueTypes:Array.from(e.keys()),valueTypeModes:Array.from(e),endianness:"Little Endian"};this.#o=Common.Settings.Settings.instance().createSetting("lmiInterpreterSettings",t)}static instance(){return controllerInstance||(controllerInstance=new LinearMemoryInspectorController,controllerInstance)}static async getMemoryForAddress(e,t){const r=Math.max(0,t-500),n=r+1e3;return{memory:await e.getRange(r,n),offset:r}}static async getMemoryRange(e,t,r){if(t<0||t>r||t>=e.length())throw new Error("Requested range is out of bounds.");const n=Math.max(r,t+1e3);return await e.getRange(t,n)}async evaluateExpression(e,t){const r=await e.evaluate({expression:t});if("error"in r)console.error(`Tried to evaluate the expression '${t}' but got an error: ${r.error}`);else{if(!("exceptionDetails"in r)||!r?.exceptionDetails?.text)return r.object;console.error(`Tried to evaluate the expression '${t}' but got an exception: ${r.exceptionDetails.text}`)}}saveSettings(e){const t=Array.from(e.valueTypes),r=[...e.modes];this.#o.set({valueTypes:t,valueTypeModes:r,endianness:e.endianness})}loadSettings(){const e=this.#o.get();return{valueTypes:new Set(e.valueTypes),modes:new Map(e.valueTypeModes),endianness:e.endianness}}getHighlightInfo(e){return this.#n.get(e)}removeHighlight(e,t){this.getHighlightInfo(e)===t&&this.#n.delete(e)}setHighlightInfo(e,t){this.#n.set(e,t)}#c(e){this.#n.delete(e)}static async retrieveDWARFMemoryObjectAndAddress(e){if(!(e instanceof Bindings.DebuggerLanguagePlugins.ExtensionRemoteObject))return;const t=e,r=e.linearMemoryAddress;if(void 0===r)return;const n=t.callFrame,o=await e.debuggerModel().agent.invoke_evaluateOnCallFrame({callFrameId:n.id,expression:"memories[0]"}),s=o.getError();s&&(console.error(s),Common.Console.Console.instance().error(i18nString(UIStrings.couldNotOpenLinearMemory)));return{obj:e.debuggerModel().runtimeModel().createRemoteObject(o.result),address:r}}static extractObjectSize(e){return e.linearMemorySize??0}static extractObjectTypeDescription(e){const t=e.description;if(!t)return"";const r=t.charAt(t.length-1),n=t.charAt(t.length-2);return"*"===r||"&"===r?" "===n?t.slice(0,t.length-2):t.slice(0,t.length-1):t}static extractObjectName(e,t){const r=e.description?.charAt(e.description.length-1);return"*"===r?"*"+t:t}async openInspectorView(e,t,r){const n=await LinearMemoryInspectorController.retrieveDWARFMemoryObjectAndAddress(e);let o=e,s=t;void 0!==n&&(s=n.address,o=n.obj),void 0!==s?Host.userMetrics.linearMemoryInspectorTarget(Host.UserMetrics.LinearMemoryInspectorTarget.DWARFInspectableAddress):"arraybuffer"===o.subtype?Host.userMetrics.linearMemoryInspectorTarget(Host.UserMetrics.LinearMemoryInspectorTarget.ArrayBuffer):"dataview"===o.subtype?Host.userMetrics.linearMemoryInspectorTarget(Host.UserMetrics.LinearMemoryInspectorTarget.DataView):"typedarray"===o.subtype?Host.userMetrics.linearMemoryInspectorTarget(Host.UserMetrics.LinearMemoryInspectorTarget.TypedArray):(console.assert("webassemblymemory"===o.subtype),Host.userMetrics.linearMemoryInspectorTarget(Host.UserMetrics.LinearMemoryInspectorTarget.WebAssemblyMemory));const i=await getBufferFromObject(o),{internalProperties:a}=await i.object().getOwnProperties(!1),c=a?.find((({name:e})=>"[[ArrayBufferData]]"===e)),l=c?.value?.value;if(!l)throw new Error("Unable to find backing store id for array buffer");const g=a?.find((({name:e})=>"[[WebAssemblyMemory]]"===e)),d=g?.value,m=LinearMemoryInspectorController.extractHighlightInfo(e,r);if(m?this.setHighlightInfo(l,m):this.#c(l),this.#r.has(l))return this.#t.reveal(l,s),void UI.ViewManager.ViewManager.instance().showView("linear-memory-inspector");const u=String(d?d.description:i.object().description);this.#r.set(l,i.object());const f=new RemoteArrayBufferWrapper(i);this.#t.create(l,u,f,s),UI.ViewManager.ViewManager.instance().showView("linear-memory-inspector")}static extractHighlightInfo(e,t){if(!(e instanceof Bindings.DebuggerLanguagePlugins.ExtensionRemoteObject))return;const r=e.linearMemoryAddress??0;let n;try{n={startAddress:r,size:LinearMemoryInspectorController.extractObjectSize(e),name:t?LinearMemoryInspectorController.extractObjectName(e,t):t,type:LinearMemoryInspectorController.extractObjectTypeDescription(e)}}catch(e){n=void 0}return n}modelRemoved(e){for(const[t,r]of this.#r)e===r.runtimeModel()&&(this.#r.delete(t),this.#c(t),this.#t.close(t))}#a(e){const t=e.data;for(const[e,r]of this.#r)if(t.runtimeModel()===r.runtimeModel()){const r=t.debuggerPausedDetails()?.callFrames[0];r?this.updateHighlightedMemory(e,r).then((()=>this.#t.refreshView(e))):(this.#c(e),this.#t.refreshView(e))}}#s(e){this.modelRemoved(e.data.runtimeModel())}#i({data:e}){const t=this.#r.get(e);t&&t.release(),this.#r.delete(e),this.#c(e)}async updateHighlightedMemory(e,t){const r=this.getHighlightInfo(e),n=r?.name;if(!r||!n)return void this.#c(e);const o=await this.evaluateExpression(t,n);if(!o)return void this.#c(e);const s=LinearMemoryInspectorController.extractHighlightInfo(o,n);s&&this.#l(s,r)?this.setHighlightInfo(e,s):this.#c(e)}#l(e,t){return e.type===t.type&&e.startAddress===t.startAddress}}