const styles=new CSSStyleSheet;styles.replaceSync("/*\n * Copyright 2022 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n.highlight-chip-list {\n  min-height: 20px;\n  display: flex;\n  flex-wrap: wrap;\n  justify-content: left;\n  align-items: center;\n  background-color: var(--color-background);\n  margin: 8px 0;\n  gap: 8px;\n  row-gap: 6px;\n}\n\n.highlight-chip {\n  background: var(--color-background);\n  border: 1px solid var(--color-button-secondary-border);\n  height: 18px;\n  border-radius: 4px;\n  flex: 0 0 auto;\n  max-width: 250px;\n  position: relative;\n  padding: 0 6px;\n}\n\n.highlight-chip:hover {\n  background-color: var(--color-background-elevation-1);\n}\n\n.delete-highlight-container {\n  display: none;\n  height: 100%;\n  position: absolute;\n  right: 0;\n  top: 0;\n  border-radius: 4px;\n  width: 24px;\n  align-items: center;\n  justify-content: center;\n}\n\n.delete-highlight-button {\n  cursor: pointer;\n  width: 13px;\n  height: 13px;\n  border: none;\n  background-color: transparent;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n\n.delete-highlight-button:hover {\n  background-color: var(--color-details-hairline);\n  border-radius: 50%;\n}\n\n.jump-to-highlight-button {\n  cursor: pointer;\n  padding: 0;\n  border: none;\n  background: none;\n  height: 100%;\n  align-items: center;\n  max-width: 100%;\n  overflow: hidden;\n}\n\n.delete-highlight-button devtools-icon {\n  width: 13px;\n  height: 13px;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  border-radius: 50%;\n}\n\n.source-code {\n  font-family: var(--source-code-font-family);\n  font-size: var(--source-code-font-size);\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  color: var(--color-text-primary);\n}\n\n.value {\n  color: var(--color-syntax-2);\n}\n\n.separator {\n  white-space: pre;\n  flex-shrink: 0;\n}\n\n.highlight-chip.focused {\n  border-color: var(--color-primary-old);\n  background-color: var(--color-button-secondary-background-hovering);\n}\n\n.highlight-chip:hover > .delete-highlight-container {\n  display: flex;\n  /* To avoid issues with stacking semi-transparent colors, we use a hardcoded solid color here. */\n  background: linear-gradient(90deg, transparent 0%, rgb(241 243 244) 25%); /* stylelint-disable-line plugin/use_theme_colors */\n}\n\n.highlight-chip.focused:hover > .delete-highlight-container {\n  /* To avoid issues with stacking semi-transparent colors, we use a hardcoded solid color here. */\n  background: linear-gradient(90deg, transparent 0%, rgb(231 241 253) 25%); /* stylelint-disable-line plugin/use_theme_colors */\n}\n\n:host-context(.-theme-with-dark-background) .highlight-chip:hover > .delete-highlight-container {\n  display: flex;\n  /* To avoid issues with stacking semi-transparent colors, we use a hardcoded solid color here. */\n  background: linear-gradient(90deg, transparent 0%, rgb(41 42 45) 25%); /* stylelint-disable-line plugin/use_theme_colors */\n}\n\n:host-context(.-theme-with-dark-background) .highlight-chip.focused:hover > .delete-highlight-container {\n  /* To avoid issues with stacking semi-transparent colors, we use a hardcoded solid color here. */\n  background: linear-gradient(90deg, transparent 0%, rgb(48 55 68) 25%); /* stylelint-disable-line plugin/use_theme_colors */\n}\n\n/*# sourceURL=linearMemoryHighlightChipList.css */\n");export default styles;