import*as Common from"../../../../core/common/common.js";import*as i18n from"../../../../core/i18n/i18n.js";import*as Platform from"../../../../core/platform/platform.js";import*as SDK from"../../../../core/sdk/sdk.js";import*as IconButton from"../../../components/icon_button/icon_button.js";import*as UI from"../../legacy.js";import fontEditorStyles from"./fontEditor.css.js";import*as FontEditorUnitConverter from"./FontEditorUnitConverter.js";import*as FontEditorUtils from"./FontEditorUtils.js";const UIStrings={fontFamily:"Font Family",cssProperties:"CSS Properties",fontSize:"Font Size",lineHeight:"Line Height",fontWeight:"Font Weight",spacing:"Spacing",fallbackS:"Fallback {PH1}",thereIsNoValueToDeleteAtIndexS:"There is no value to delete at index: {PH1}",fontSelectorDeletedAtIndexS:"Font Selector deleted at index: {PH1}",deleteS:"Delete {PH1}",PleaseEnterAValidValueForSText:"* Please enter a valid value for {PH1} text input",thisPropertyIsSetToContainUnits:"This property is set to contain units but does not have a defined corresponding unitsArray: {PH1}",sSliderInput:"{PH1} Slider Input",sTextInput:"{PH1} Text Input",units:"Units",sUnitInput:"{PH1} Unit Input",sKeyValueSelector:"{PH1} Key Value Selector",sToggleInputType:"{PH1} toggle input type",selectorInputMode:"Selector Input Mode",sliderInputMode:"Slider Input Mode"},str_=i18n.i18n.registerUIStrings("ui/legacy/components/inline_editor/FontEditor.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class FontEditor extends(Common.ObjectWrapper.eventMixin(UI.Widget.VBox)){selectedNode;propertyMap;fontSelectorSection;fontSelectors;fontsList;constructor(t){super(!0),this.selectedNode=UI.Context.Context.instance().flavor(SDK.DOMModel.DOMNode),this.propertyMap=t,this.contentElement.tabIndex=0,this.setDefaultFocusedElement(this.contentElement),this.fontSelectorSection=this.contentElement.createChild("div","font-selector-section"),this.fontSelectorSection.createChild("h2","font-section-header").textContent=i18nString(UIStrings.fontFamily),this.fontSelectors=[],this.fontsList=null;const e=this.propertyMap.get("font-family");this.createFontSelectorSection(e);const i=this.contentElement.createChild("div","font-section");i.createChild("h2","font-section-header").textContent=i18nString(UIStrings.cssProperties);const n=this.getPropertyInfo("font-size",FontEditorUtils.FontSizeStaticParams.regex),s=this.getPropertyInfo("line-height",FontEditorUtils.LineHeightStaticParams.regex),o=this.getPropertyInfo("font-weight",FontEditorUtils.FontWeightStaticParams.regex),r=this.getPropertyInfo("letter-spacing",FontEditorUtils.LetterSpacingStaticParams.regex);new FontPropertyInputs("font-size",i18nString(UIStrings.fontSize),i,n,FontEditorUtils.FontSizeStaticParams,this.updatePropertyValue.bind(this),this.resizePopout.bind(this),!0),new FontPropertyInputs("line-height",i18nString(UIStrings.lineHeight),i,s,FontEditorUtils.LineHeightStaticParams,this.updatePropertyValue.bind(this),this.resizePopout.bind(this),!0),new FontPropertyInputs("font-weight",i18nString(UIStrings.fontWeight),i,o,FontEditorUtils.FontWeightStaticParams,this.updatePropertyValue.bind(this),this.resizePopout.bind(this),!1),new FontPropertyInputs("letter-spacing",i18nString(UIStrings.spacing),i,r,FontEditorUtils.LetterSpacingStaticParams,this.updatePropertyValue.bind(this),this.resizePopout.bind(this),!0)}wasShown(){this.registerCSSFiles([fontEditorStyles])}async createFontSelectorSection(t){if(t){const e=t.split(",");if(await this.createFontSelector(e[0],!0),!FontEditorUtils.GlobalValues.includes(e[0]))for(let t=1;t<e.length+1;t++)this.createFontSelector(e[t])}else this.createFontSelector("",!0);this.resizePopout()}async createFontsList(){const t=await FontEditorUtils.generateComputedFontArray(),e=new Map,i=this.splitComputedFontArray(t);e.set("Computed Fonts",i);const n=new Map;n.set("System Fonts",FontEditorUtils.SystemFonts),n.set("Generic Families",FontEditorUtils.GenericFonts);const s=[];return s.push(e),s.push(n),s}splitComputedFontArray(t){const e=[];for(const i of t)if(i.includes(",")){i.split(",").forEach((t=>{-1===e.findIndex((e=>e.toLowerCase()===t.trim().toLowerCase().replace(/"/g,"'")))&&e.push(t.trim().replace(/"/g,""))}))}else-1===e.findIndex((t=>t.toLowerCase()===i.toLowerCase().replace('"',"'")))&&e.push(i.replace(/"/g,""));return e}async createFontSelector(t,e){if(t=t?t.trim():""){const e=t.charAt(0);"'"===e?t=t.replace(/'/g,""):'"'===e&&(t=t.replace(/"/g,""))}const i=this.fontSelectorSection.createChild("div","shadow-editor-field shadow-editor-flex-field");let n;if(this.fontsList||(this.fontsList=await this.createFontsList()),e){n=i18nString(UIStrings.fontFamily);const e=new Map([["Global Values",FontEditorUtils.GlobalValues]]),s=[...this.fontsList];s.push(e),this.createSelector(i,n,s,t.trim())}else n=i18nString(UIStrings.fallbackS,{PH1:this.fontSelectors.length}),this.createSelector(i,n,this.fontsList,t.trim())}deleteFontSelector(t,e){let i=this.fontSelectors[t];const n=0===t;if(""===i.input.value&&!e)return void UI.ARIAUtils.alert(i18nString(UIStrings.thereIsNoValueToDeleteAtIndexS,{PH1:t}));if(n){const e=this.fontSelectors[1];let n="";e&&(n=e.input.value,i=e);this.fontSelectors[0].input.value=n,t=1}if(i.input.parentNode){const e=this.fontSelectors.length>1;if(!n||e){const e=i.input.parentElement;e&&(e.remove(),this.fontSelectors.splice(t,1),this.updateFontSelectorList())}UI.ARIAUtils.alert(i18nString(UIStrings.fontSelectorDeletedAtIndexS,{PH1:t}))}this.onFontSelectorChanged(),this.resizePopout();const s=n?0:t-1;this.fontSelectors[s].input.focus()}updateFontSelectorList(){for(let t=0;t<this.fontSelectors.length;t++){const e=this.fontSelectors[t];let i;i=0===t?i18nString(UIStrings.fontFamily):i18nString(UIStrings.fallbackS,{PH1:t}),e.label.textContent=i,UI.ARIAUtils.setLabel(e.input,i),e.deleteButton.setTitle(i18nString(UIStrings.deleteS,{PH1:i})),e.index=t}}getPropertyInfo(t,e){const i=this.propertyMap.get(t);if(i){const t=i,n=t.match(e);if(n){return{value:"+"===n[1].charAt(0)?n[1].substr(1):n[1],units:n[2]?n[2]:""}}return{value:t,units:null}}return{value:null,units:null}}createSelector(t,e,i,n){const s=this.fontSelectors.length,o=UI.UIUtils.createSelect(e,i);o.value=n;const r=UI.UIUtils.createLabel(e,"shadow-editor-label",o);o.addEventListener("input",this.onFontSelectorChanged.bind(this),!1),o.addEventListener("keydown",(t=>{"Enter"===t.key&&t.consume()}),!1),t.appendChild(r),t.appendChild(o);const a=new UI.Toolbar.Toolbar("",t),l=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.deleteS,{PH1:e}),"bin");a.appendToolbarItem(l);const p={label:r,input:o,deleteButton:l,index:s};l.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>{this.deleteFontSelector(p.index)})),l.element.addEventListener("keydown",(t=>{Platform.KeyboardUtilities.isEnterOrSpaceKey(t)&&(this.deleteFontSelector(p.index),t.consume())}),!1),this.fontSelectors.push(p)}onFontSelectorChanged(){let t="";const e=FontEditorUtils.GlobalValues.includes(this.fontSelectors[0].input.value);if(e)for(let t=1;t<this.fontSelectors.length;t++)this.deleteFontSelector(t,!0);for(const e of this.fontSelectors){const i=e.input;""!==i.value&&(""===t?t=this.fontSelectors[0].input.value:t+=", "+i.value)}""!==this.fontSelectors[this.fontSelectors.length-1].input.value&&!e&&this.fontSelectors.length<10&&(this.createFontSelector(""),this.resizePopout()),this.updatePropertyValue("font-family",t)}updatePropertyValue(t,e){this.dispatchEventToListeners(Events.FontChanged,{propertyName:t,value:e})}resizePopout(){this.dispatchEventToListeners(Events.FontEditorResized)}}export var Events;!function(t){t.FontChanged="FontChanged",t.FontEditorResized="FontEditorResized"}(Events||(Events={}));class FontPropertyInputs{showSliderMode;errorText;propertyInfo;propertyName;staticParams;hasUnits;units;addedUnit;initialRange;boundUpdateCallback;boundResizeCallback;selectedNode;sliderInput;textBoxInput;unitInput;selectorInput;applyNextInput;constructor(t,e,i,n,s,o,r,a){this.showSliderMode=!0;const l=i.createChild("div","shadow-editor-field shadow-editor-flex-field");if(this.errorText=i.createChild("div","error-text"),this.errorText.textContent=i18nString(UIStrings.PleaseEnterAValidValueForSText,{PH1:t}),this.errorText.hidden=!0,UI.ARIAUtils.markAsAlert(this.errorText),this.propertyInfo=n,this.propertyName=t,this.staticParams=s,this.hasUnits=a,this.hasUnits&&this.staticParams.units&&null!==this.staticParams.defaultUnit){const t=this.staticParams.defaultUnit;this.units=null!==n.units?n.units:t,this.addedUnit=!this.staticParams.units.has(this.units)}else{if(this.hasUnits)throw new Error(i18nString(UIStrings.thisPropertyIsSetToContainUnits,{PH1:t}));this.units=""}this.initialRange=this.getUnitRange(),this.boundUpdateCallback=o,this.boundResizeCallback=r,this.selectedNode=UI.Context.Context.instance().flavor(SDK.DOMModel.DOMNode);const p=UI.UIUtils.createLabel(e,"shadow-editor-label");l.append(p),this.sliderInput=this.createSliderInput(l,e),this.textBoxInput=this.createTextBoxInput(l),UI.ARIAUtils.bindLabelToControl(p,this.textBoxInput),this.unitInput=this.createUnitInput(l),this.selectorInput=this.createSelectorInput(l),this.createTypeToggle(l),this.checkSelectorValueAndToggle(),this.applyNextInput=!1}setInvalidTextBoxInput(t){t?this.errorText.hidden&&(this.errorText.hidden=!1,this.textBoxInput.classList.add("error-input"),this.boundResizeCallback()):this.errorText.hidden||(this.errorText.hidden=!0,this.textBoxInput.classList.remove("error-input"),this.boundResizeCallback())}checkSelectorValueAndToggle(){return!(!this.staticParams.keyValues||null===this.propertyInfo.value||!this.staticParams.keyValues.has(this.propertyInfo.value))&&(this.toggleInputType(),!0)}getUnitRange(){let t=0,e=100,i=1;if(null!==this.propertyInfo.value&&/\d/.test(this.propertyInfo.value))if(this.staticParams.rangeMap.get(this.units)){const n=this.staticParams.rangeMap.get(this.units);n&&(t=Math.min(n.min,parseFloat(this.propertyInfo.value)),e=Math.max(n.max,parseFloat(this.propertyInfo.value)),i=n.step)}else{const n=this.staticParams.rangeMap.get("px");n&&(t=Math.min(n.min,parseFloat(this.propertyInfo.value)),e=Math.max(n.max,parseFloat(this.propertyInfo.value)),i=n.step)}else{const n=this.staticParams.rangeMap.get(this.units);n&&(t=n.min,e=n.max,i=n.step)}return{min:t,max:e,step:i}}createSliderInput(t,e){const i=this.initialRange.min,n=this.initialRange.max,s=this.initialRange.step,o=UI.UIUtils.createSlider(i,n,-1);if(o.sliderElement.step=s.toString(),o.sliderElement.tabIndex=0,this.propertyInfo.value)o.value=parseFloat(this.propertyInfo.value);else{const t=(i+n)/2;o.value=t}return o.addEventListener("input",(t=>{this.onSliderInput(t,!1)})),o.addEventListener("mouseup",(t=>{this.onSliderInput(t,!0)})),o.addEventListener("keydown",(t=>{"ArrowUp"!==t.key&&"ArrowDown"!==t.key&&"ArrowLeft"!==t.key&&"ArrowRight"!==t.key||(this.applyNextInput=!0)})),t.appendChild(o),UI.ARIAUtils.setLabel(o.sliderElement,i18nString(UIStrings.sSliderInput,{PH1:this.propertyName})),o}createTextBoxInput(t){const e=UI.UIUtils.createInput("shadow-editor-text-input","number");return e.step=this.initialRange.step.toString(),e.classList.add("font-editor-text-input"),null!==this.propertyInfo.value&&("+"===this.propertyInfo.value.charAt(0)&&(this.propertyInfo.value=this.propertyInfo.value.substr(1)),e.value=this.propertyInfo.value),e.step="any",e.addEventListener("input",this.onTextBoxInput.bind(this),!1),t.appendChild(e),UI.ARIAUtils.setLabel(e,i18nString(UIStrings.sTextInput,{PH1:this.propertyName})),e}createUnitInput(t){let e;if(this.hasUnits&&this.staticParams.units){const t=this.propertyInfo.units,i=this.staticParams.units;e=UI.UIUtils.createSelect(i18nString(UIStrings.units),i),e.classList.add("font-editor-select"),this.addedUnit&&t&&e.add(new Option(t,t)),t&&(e.value=t),e.addEventListener("change",this.onUnitInput.bind(this),!1)}else e=UI.UIUtils.createSelect(i18nString(UIStrings.units),[]),e.classList.add("font-editor-select"),e.disabled=!0;return e.addEventListener("keydown",(t=>{"Enter"===t.key&&t.consume()}),!1),t.appendChild(e),UI.ARIAUtils.setLabel(e,i18nString(UIStrings.sUnitInput,{PH1:this.propertyName})),e}createSelectorInput(t){const e=UI.UIUtils.createSelect(i18nString(UIStrings.sKeyValueSelector,{PH1:this.propertyName}),this.staticParams.keyValues);return e.classList.add("font-selector-input"),this.propertyInfo.value&&(e.value=this.propertyInfo.value),e.addEventListener("input",this.onSelectorInput.bind(this),!1),e.addEventListener("keydown",(t=>{"Enter"===t.key&&t.consume()}),!1),t.appendChild(e),e.hidden=!0,e}onSelectorInput(t){if(t.currentTarget){const e=t.currentTarget.value;this.textBoxInput.value="";const i=(parseFloat(this.sliderInput.sliderElement.min)+parseFloat(this.sliderInput.sliderElement.max))/2;this.sliderInput.value=i,this.setInvalidTextBoxInput(!1),this.boundUpdateCallback(this.propertyName,e)}}onSliderInput(t,e){const i=t.currentTarget;if(i){const t=i.value;this.textBoxInput.value=t,this.selectorInput.value="";const n=this.hasUnits?t+this.unitInput.value:t.toString();this.setInvalidTextBoxInput(!1),(e||this.applyNextInput)&&(this.boundUpdateCallback(this.propertyName,n),this.applyNextInput=!1)}}onTextBoxInput(t){const e=t.currentTarget;if(e){const t=e.value,i=t+(""===t?"":this.unitInput.value);this.staticParams.regex.test(i)||""===t&&!e.validationMessage.length?(parseFloat(t)>parseFloat(this.sliderInput.sliderElement.max)?this.sliderInput.sliderElement.max=t:parseFloat(t)<parseFloat(this.sliderInput.sliderElement.min)&&(this.sliderInput.sliderElement.min=t),this.sliderInput.value=parseFloat(t),this.selectorInput.value="",this.setInvalidTextBoxInput(!1),this.boundUpdateCallback(this.propertyName,i)):this.setInvalidTextBoxInput(!0)}}async onUnitInput(t){const e=t.currentTarget,i=e.hasFocus(),n=e.value;e.disabled=!0;const s=this.units,o=await FontEditorUnitConverter.getUnitConversionMultiplier(s,n,"font-size"===this.propertyName);this.setInputUnits(o,n),this.textBoxInput.value&&this.boundUpdateCallback(this.propertyName,this.textBoxInput.value+n),this.units=n,e.disabled=!1,i&&e.focus()}createTypeToggle(t){const e=t.createChild("div","spectrum-switcher"),i=new IconButton.Icon.Icon;i.data={iconName:"fold-more",color:"var(--icon-default)",width:"16px",height:"16px"},e.appendChild(i),UI.UIUtils.setTitle(e,i18nString(UIStrings.sToggleInputType,{PH1:this.propertyName})),e.tabIndex=0,self.onInvokeElement(e,this.toggleInputType.bind(this)),UI.ARIAUtils.markAsButton(e)}toggleInputType(t){t&&"Enter"===t.key&&t.consume(),this.showSliderMode?(this.sliderInput.hidden=!0,this.textBoxInput.hidden=!0,this.unitInput.hidden=!0,this.selectorInput.hidden=!1,this.showSliderMode=!1,UI.ARIAUtils.alert(i18nString(UIStrings.selectorInputMode))):(this.sliderInput.hidden=!1,this.textBoxInput.hidden=!1,this.unitInput.hidden=!1,this.selectorInput.hidden=!0,this.showSliderMode=!0,UI.ARIAUtils.alert(i18nString(UIStrings.sliderInputMode)))}setInputUnits(t,e){const i=this.staticParams.rangeMap.get(e);let n,s,o;i?(n=i.min,s=i.max,o=i.step):(n=0,s=100,o=1);let r=!1;const a=FontEditorUtils.getRoundingPrecision(o);let l=(n+s)/2;this.textBoxInput.value&&(r=!0,l=parseFloat((parseFloat(this.textBoxInput.value)*t).toFixed(a))),this.sliderInput.sliderElement.min=Math.min(l,n).toString(),this.sliderInput.sliderElement.max=Math.max(l,s).toString(),this.sliderInput.sliderElement.step=o.toString(),this.textBoxInput.step=o.toString(),r&&(this.textBoxInput.value=l.toString()),this.sliderInput.value=l}}